/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

#include <GL/glut.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// stae do obsugi menu podrcznego

enum
{
    EXIT = 500                  // wyjcie
};

// wywietlane cigi znakw

char string_button [100] = "";
char string_pos [100] = "";
char string_entry [100] = "";

// wywietlenie sceny 3D

void DisplayScene ()
{
    // kolor ta - zawarto bufora koloru
    glClearColor (1.0,1.0,1.0,1.0);

    // czyszczenie bufora koloru
    glClear (GL_COLOR_BUFFER_BIT);

    // kolor wywietlanych napisw
    glColor3f (1.0,0.0,0.0);

    // pooenie pierwszego napisu
    glRasterPos2f (-0.5,0.5);

    // wywietlenie pierwszego napisu
    for (int i = 0; i < strlen (string_button); i++)
        glutBitmapCharacter (GLUT_BITMAP_TIMES_ROMAN_24,string_button [i]);

    // pooenie drugiego napisu
    glRasterPos2f (-0.5,0.0);

    // wywietlenie drugiego napisu
    for (int i = 0; i < strlen (string_pos); i++)
        glutBitmapCharacter (GLUT_BITMAP_TIMES_ROMAN_24,string_pos [i]);

    // pooenie trzeciego napisu
    glRasterPos2f (-0.5,-0.5);

    // wywietlenie trzeciego napisu
    for (int i = 0; i < strlen (string_entry); i++)
        glutBitmapCharacter (GLUT_BITMAP_TIMES_ROMAN_24,string_entry [i]);

    // skierowanie polece do wykonania
    glFlush ();

    // zamiana buforw koloru
    glutSwapBuffers ();
}

// zmiana wielkoci okna

void Reshape (int Width,int Height)
{
    // obszar renderingu - cae okno
    glViewport (0,0,Width,Height);

    // wybr macierzy rzutowania
    glMatrixMode (GL_PROJECTION);

    // macierz rzutowania = macierz jednostkowa
    glLoadIdentity ();

    // rzutowanie prostoktne
    glOrtho (-1.0,1.0,-1.0,1.0,-1.0,1.0);

    // wywietlenie okna
    DisplayScene ();
}

// obsuga przyciskw myszki

void MouseButton (int button, int state, int x, int y)
{
    // sprawdzenie, czy przycisk zosta przycinity
    if (state == GLUT_DOWN)
        switch (state)
        {
            // wybr napisu
            case GLUT_LEFT_BUTTON:
            strcpy (string_button,"GLUT_LEFT_BUTTON");
            break;
            case GLUT_RIGHT_BUTTON:
            strcpy (string_button,"GLUT_RIGHT_BUTTON");
            break;
            case GLUT_MIDDLE_BUTTON:
            strcpy (string_button,"GLUT_MIDDLE_BUTTON");
            break;
        }
    else
        // wyzerowanie cigu znakw
        string_button [0] = '\0';

    // odrysowanie okna
    DisplayScene ();
}

// obsuga ruchu kursora myszki

void MouseMotion (int x, int y)
{
    // pooenie kursora myszki
    sprintf (string_pos,"X=%i Y=%i",x,y);

    // odrysowanie okna
    DisplayScene ();
}

// obsuga przekroczenia granicy okna

void MouseEntry (int state)
{
    // sprawdzenie statusu
    if (state == GLUT_LEFT)
        strcpy (string_entry,"GLUT_LEFT");
    else
        if (state == GLUT_ENTERED)
            strcpy (string_entry,"GLUT_ENTERED");

    // odrysowanie okna
    DisplayScene ();
}

// obsuga menu podrcznego

void Menu (int value)
{
    if (value == EXIT)
        exit (0);
}

int main (int argc, char *argv[])
{
    // inicjalizacja biblioteki GLUT
    glutInit (&argc,argv);

    // inicjalizacja bufora ramki
    glutInitDisplayMode (GLUT_DOUBLE|GLUT_RGB);

    // rozmiary gwnego okna programu
    glutInitWindowSize (400,300);

    // utworzenie gwnego okna programu
    glutCreateWindow ("Myszka");

    // doczenie funkcji generujcej scen 3D
    glutDisplayFunc (DisplayScene);

    // doczenie funkcji wywoywanej przy zmianie rozmiaru okna
    glutReshapeFunc (Reshape);

    // obsuga przyciskw myszki
    glutMouseFunc (MouseButton);

    // obsuga ruchu kursora myszki
    glutMotionFunc (MouseMotion);
    glutPassiveMotionFunc (MouseMotion);

    // obsuga przekroczenia granicy okna
    glutEntryFunc (MouseEntry);

    // menu gwne
    glutCreateMenu (Menu);
#ifdef WIN32

    glutAddMenuEntry ("Wyjcie",EXIT);
#else

    glutAddMenuEntry ("Wyjscie",EXIT);
#endif

    // okrelenie przycisku myszki obsugujcego menu podrczne
    glutAttachMenu (GLUT_RIGHT_BUTTON);

    // wprowadzenie programu do obsugi ptli komunikatw
    glutMainLoop ();
    return 0;
}
