/*
(c) Janusz Ganczarski
http://www.januszg.hg.pl
JanuszG@enter.net.pl
*/

#ifndef __FILTERS__H__
#define __FILTERS__H__

#include <GL/gl.h>

// filtr uredniajcy

GLfloat average [9] =
    {
        0.11111111, 0.11111111, 0.111111111,
        0.11111111, 0.11111111, 0.111111111,
        0.11111111, 0.11111111, 0.111111111
    };

// filtr LP1

GLfloat lp1 [9] =
    {
        0.1, 0.1, 0.1,
        0.1, 0.2, 0.1,
        0.1, 0.1, 0.1
    };

// filtr LP2

GLfloat lp2 [9] =
    {
        0.08333333, 0.08333333, 0.08333333,
        0.08333333, 0.33333333, 0.08333333,
        0.08333333, 0.08333333, 0.08333333
    };

// filtr LP3

GLfloat lp3 [9] =
    {
        0.05, 0.05, 0.05,
        0.05, 0.60, 0.05,
        0.05, 0.05, 0.05
    };

// filtr Gaussa

GLfloat gauss [9] =
    {
        0.0625, 0.1250, 0.0625,
        0.1250, 0.2500, 0.1250,
        0.0625, 0.1250, 0.0625
    };

// filtr usuwajcy redni

GLfloat mean_removal [9] =
    {
        -1, -1, -1,
        -1,  9, -1,
        -1, -1, -1
    };

// filtr HP1

GLfloat hp1 [9] =
    {
        0, -1,  0,
        -1,  5, -1,
        0, -1,  0
    };

// filtr HP2

GLfloat hp2 [9] =
    {
        1, -2,  1,
        -2,  5, -2,
        1, -2,  1
    };

// filtr HP3

GLfloat hp3 [9] =
    {
        0.0000, -0.0625,  0.0000,
        -0.0625, 1.2500, -0.0625,
        0.0000, -0.0625,  0.0000
    };

// filtr poziomy

GLfloat horizontal [9] =
    {
        0, -1, 0,
        0,  1, 0,
        0,  0, 0
    };

// filtr pionowy

GLfloat vertical [9] =
    {
        0, 0, 0,
        -1, 1, 0,
        0, 0, 0
    };

// filtr poziomy/pionowy

GLfloat horizontal_vertical [9] =
    {
        -1, 0, 0,
        0, 1, 0,
        0, 0, 0
    };

// filtr gradientowy wschd

GLfloat gradient_east [9] =
    {
        -1,  1, 1,
        -1, -2, 1,
        -1,  1, 1
    };

// filtr gradientowy poudniowy wschd

GLfloat gradient_south_east [9] =
    {
        -1, -1, 1,
        -1, -2, 1,
        1,  1, 1
    };

// filtr gradientowy poudnie

GLfloat gradient_south [9] =
    {
        -1, -1, -1,
        1, -2,  1,
        1,  1,  1
    };

// filtr gradientowy poudniowy zachd

GLfloat gradient_south_west [9] =
    {
        1, -1, -1,
        1, -2, -1,
        1,  1,  1
    };

// filtr gradientowy zachd

GLfloat gradient_west [9] =
    {
        1,  1, -1,
        1, -2, -1,
        1,  1, -1
    };

// filtr gradientowy pnocny zachd

GLfloat gradient_north_west [9] =
    {
        1,  1,  1,
        1, -2, -1,
        1, -1, -1
    };

// filtr gradientowy pnoc

GLfloat gradient_north [9] =
    {
        1,  1,  1,
        1, -2,  1,
        -1, -1, -1
    };

// filtr gradientowy pnocny wschd

GLfloat gradient_north_east [9] =
    {
        1,  1, 1,
        -1, -2, 1,
        -1, -1, 1
    };

// filtr uwypuklajcy wschd

GLfloat emboss_east [9] =
    {
        -1, 0, 1,
        -1, 1, 1,
        -1, 0, 1
    };

// filtr uwypuklajcy poudniowy wschd

GLfloat emboss_south_east [9] =
    {
        -1, -1, 0,
        -1,  1, 1,
        0,  1, 1
    };

// filtr uwypuklajcy poudnie

GLfloat emboss_south [9] =
    {
        -1, -1, -1,
        0,  1,  0,
        1,  1,  1
    };

// filtr uwypuklajcy poudniowy zachd

GLfloat emboss_south_west [9] =
    {
        0, -1, -1,
        1,  1, -1,
        1,  1,  0
    };

// filtr uwypuklajcy zachd

GLfloat emboss_west [9] =
    {
        1, 0, -1,
        1, 1, -1,
        1, 0, -1
    };

// filtr uwypuklajcy pnocny zachd

GLfloat emboss_north_west [9] =
    {
        1,  1,  0,
        1,  1, -1,
        0, -1, -1
    };

// filtr uwypuklajcy pnoc

GLfloat emboss_north [9] =
    {
        1,  1,  1,
        0,  1,  0,
        -1, -1, -1
    };

// filtr uwypuklajcy pnocny wschd

GLfloat emboss_north_east [9] =
    {
        0,  1, 1,
        -1,  1, 1,
        -1, -1, 0
    };

// filtr Laplace'a LAPL1

GLfloat laplacian_lapl1 [9] =
    {
        0, -1,  0,
        -1,  4, -1,
        0, -1,  0
    };

// filtr Laplace'a LAPL2

GLfloat laplacian_lapl2 [9] =
    {
        -1, -1, -1,
        -1,  8, -1,
        -1, -1, -1
    };

// filtr Laplace'a LAPL3

GLfloat laplacian_lapl3 [9] =
    {
        1, -2,  1,
        -2,  4, -2,
        1, -2,  1
    };

// filtr Laplace'a skony

GLfloat laplacian_diagonal [9] =
    {
        -1, 0, -1,
        0, 4,  0,
        -1, 0, -1
    };

// filtr Laplace'a poziomy

GLfloat laplacian_horizontal [9] =
    {
        0, -1, 0,
        0,  2, 0,
        0, -1, 0
    };

// filtr Laplace'a pionowy

GLfloat laplacian_vertical [9] =
    {
        0, 0,  0,
        -1, 2, -1,
        0, 0,  0
    };

// filtr poziomy Sobela

GLfloat sobel_horizontal [9] =
    {
        1,  2,  1,
        0,  0,  0,
        -1, -2, -1
    };

// filtr pionowy Sobela

GLfloat sobel_vertical [9] =
    {
        1, 0, -1,
        2, 0, -2,
        1, 0, -1
    };

// filtr poziomy Prewitta

GLfloat prewitt_horizontal [9] =
    {
        -1, -1, -1,
        0,  0,  0,
        1,  1,  1
    };

// filtr pionowy Prewitta

GLfloat prewitt_vertical [9] =
    {
        1, 0, -1,
        1, 0, -1,
        1, 0, -1
    };

#endif // __FILTERS__H__
